//configuration, network id is access code of network

var networkId = "";

//host needs to be go.engagephd.com (not go.pinghd.com) or dev.pinghd.com

var host = "";


console.log("Engage Local Area Network Sync\n\n");
//https://www.npmjs.com/package/nodejs-websocket
//https://www.w3.org/2010/05/video/mediaevents.html

var os = require('os');
var ifaces = os.networkInterfaces();

Object.keys(ifaces).forEach(function (ifname) {
  var alias = 0;

  ifaces[ifname].forEach(function (iface) {
    if ('IPv4' !== iface.family || iface.internal !== false) {
      // skip over internal (i.e. 127.0.0.1) and non-ipv4 addresses
      return;
    }

    if (alias >= 1) {
      // this single interface has multiple ipv4 addresses
      console.log(ifname + ':' + alias, iface.address);
    } else {
      // this interface has only one ipv4 adress
      console.log(ifname, iface.address);
    }
    ++alias;
  });
});

console.log("\n\nStarting server on port 8001....\n\n");


var ws = require("nodejs-websocket");

var url = "ws://" + host + "/Sockets/EngageSocket.ashx?player=" + networkId;

var client;



var master = [];

function ConfigureClient()
{
	client = ws.connect(url);

	client.on("error", function(err)
	{
		console.log(new Date() + " Connection to Engage Server error: " + err.message);

	});

	client.on("close", function(err)
	{
		console.log(new Date() + " Connection to Engage Server closed, retrying in 10 seconds");

		setTimeout(function()
		{
			ConfigureClient();

		}, 10000);

	});

	client.on("connect", function(err)
	{
		console.log(new Date() + " Connected to Engage server");

	});

	client.on("text", function(str)
	{
		var data = eval("(" + str + ")");

		console.log(new Date() + " Group [" + data.Group + "] Interrupt [" + data.Interrupt + "] master: " + GetMaster(data.Group));
		broadcast(data.Interrupt + "_" + data.End + "_" + data.Time, data.Group);

	});

}

if (host != "")
	ConfigureClient();


var server = ws.createServer(function (conn) {

	ConfigureConn(conn);

}).listen(8001);

function GetMaster(group)
{
	for (var x = 0; x < master.length; x++)
	{
		//console.log(master[x].Group + " " + master[x].Player);

		if (master[x].Group == group)
			return master[x].Player;
	}

	return "";
}

function SetMaster(group, player)
{
	var found = false;
	for (var x = 0; x < master.length; x++)
	{
		if (master[x].Group == group)
		{
			master[x].Player = player;
			found = true;
		}
	}

	if (!found)
		master.push({ Group: group, Player: player });
}


function ConfigureConn(conn)
{
	var id = conn.path.substring(1);
	var groupId = "";

	var sp = id.split('_');
	groupId = sp[0];

	var m = GetMaster(groupId);

	if (m == "")
	{
		m = id;
		SetMaster(groupId, m);


		//TODO: send reset to player
	}

	var count = 0;
	server.connections.forEach(function (connection)
	{
		var idx = connection.path.substring(1);
		var spx = idx.split('_');
		var groupIdx = spx[0];

		if (groupId == groupIdx)
			count++;
	});

	console.log(new Date() + " New connection " + id + ", group: " + groupId + ", master: " + m + ", len: " + count);

	conn.sendText("control " + m);

	conn.on("text", function (str)
	{
		broadcast(str, groupId);
	});

	conn.on("close", function (code, reason)
	{
		console.log(new Date() + " Connection closed " + id)
		if (id == GetMaster(groupId))
		{
			CheckMaster(groupId);
		}
	});

	conn.on("error", function(errObj)
	{
		try
		{
			console.log(new Date() + " " + id + " conn err: " + JSON.stringify(errObj));
			//if (id == GetMaster(groupId))
			//{
				//CheckMaster(groupId);
			//}
		}
		catch (sup){}
	});
}

function CheckMaster(g)
{
	//find new master
	console.log(new Date() + " need new master for group: " + g);

	SetMaster(g, "");

	server.connections.forEach(function (connection)
	{
		var cid = connection.path.substring(1);

		var groupId = "";
		var sp = cid.split('_');
		groupId = sp[0];

		if (groupId == g)
		{
			if (GetMaster(g) == "")
				SetMaster(g, cid);
			connection.sendText("control " + GetMaster(g));
		}
	});
}

server.on("error", function(errObj)
{
	console.log(new Date() + " err: " + JSON.stringify(errObj));
});

function broadcast(str, g)
{
	server.connections.forEach(function (connection)
	{
		var id = connection.path.substring(1);
		var groupId = "";

		var sp = id.split('_');
		groupId = sp[0];

		//console.log(groupId + " -- " + g);

		if (groupId == g)
		{
			console.log(new Date() + " " + groupId + ": " + str);
			connection.sendText(str)
		}
	});
}
